From: =?utf-8?b?0JvQsNCx0L7RgNCw0YLQvtGA0LjRjyA1MA==?= <team@lab50.net>
Date: Mon, 10 May 2021 15:14:28 +0300
Subject: using-reflection-for-jakarta-loading

===================================================================
---
 build.properties.default                           |  12 ---
 build.xml                                          |  22 ----
 .../apache/catalina/loader/LocalStrings.properties |   1 +
 java/org/apache/catalina/loader/WebappLoader.java  |  28 +++--
 java/org/apache/catalina/startup/HostConfig.java   | 114 ---------------------
 .../catalina/startup/LocalStrings.properties       |   1 -
 6 files changed, 18 insertions(+), 160 deletions(-)

diff --git a/build.properties.default b/build.properties.default
index 7f16ab0..d2202af 100644
--- a/build.properties.default
+++ b/build.properties.default
@@ -311,15 +311,3 @@ osgi-annotations.checksum.value=153054f987534244f95a399539b11375|b6e802bceba0682
 osgi-annotations.home=${base.path}/osgi-annotations-${osgi-annotations.version}
 osgi-annotations.jar=${osgi-annotations.home}/org.osgi.annotation.bundle-${osgi-annotations.version}.jar
 osgi-annotations.loc=${base-maven.loc}/org/osgi/org.osgi.annotation.bundle/${osgi-annotations.version}/org.osgi.annotation.bundle-${osgi-annotations.version}.jar
-
-# ----- Tomcat Migration Tool for Jakarta EE -----
-migration-lib.version=1.0.0
-
-# checksums for jakartaee-migration-1.0.0-shaded.jar
-migration-lib.checksum.enabled=true
-migration-lib.checksum.algorithm=MD5|SHA-1
-migration-lib.checksum.value=cecc0fa3b5947dd52465ed395ba3f23f|19a3e36dec08bbc60ab511651887375c0a7e4d1b
-
-migration-lib.home=${base.path}/migration-${migration-lib.version}
-migration-lib.jar=${migration-lib.home}/jakartaee-migration-${migration-lib.version}-shaded.jar
-migration-lib.loc=${base-maven.loc}/org/apache/tomcat/jakartaee-migration/${migration-lib.version}/jakartaee-migration-${migration-lib.version}-shaded.jar
diff --git a/build.xml b/build.xml
index 6f096e3..f5e9472 100644
--- a/build.xml
+++ b/build.xml
@@ -244,7 +244,6 @@
     <pathelement location="${jdt.jar}"/>
     <pathelement location="${jaxrpc-lib.jar}"/>
     <pathelement location="${wsdl4j-lib.jar}"/>
-    <pathelement location="${migration-lib.jar}"/>
   </path>
 
   <path id="tomcat.classpath">
@@ -1494,17 +1493,6 @@
     </delete>
     <copy file="${jdt.jar}" todir="${tomcat.build}/lib"/>
 
-    <!-- Delete all other versions of Tomcat Migration Tool for Jakarta EE and copy the current one -->
-    <local name="migration.jar.filename" />
-    <basename property="migration.jar.filename" file="${migration-lib.jar}"/>
-    <delete verbose="true">
-      <fileset dir="${tomcat.build}/lib">
-        <include name="jakartaee-migration-*.jar"/>
-        <exclude name="${migration-lib.jar.filename}"/>
-      </fileset>
-    </delete>
-    <copy file="${migration-lib.jar}" todir="${tomcat.build}/lib"/>
-
     <!-- Add sources for examples -->
     <antcall target="examples-sources" />
   </target>
@@ -3233,16 +3221,6 @@ skip.installer property in build.properties" />
       <param name="checksum.value" value="${wsdl4j-lib.checksum.value}"/>
     </antcall>
 
-    <!-- Tomcat Migration Tool for Jakarta EE -->
-    <antcall target="downloadfile">
-      <param name="sourcefile" value="${migration-lib.loc}"/>
-      <param name="destfile" value="${migration-lib.jar}"/>
-      <param name="destdir" value="${migration-lib.home}"/>
-      <param name="checksum.enabled" value="${migration-lib.checksum.enabled}"/>
-      <param name="checksum.algorithm" value="${migration-lib.checksum.algorithm}"/>
-      <param name="checksum.value" value="${migration-lib.checksum.value}"/>
-    </antcall>
-
   </target>
 
   <target name="download-test-compile"
diff --git a/java/org/apache/catalina/loader/LocalStrings.properties b/java/org/apache/catalina/loader/LocalStrings.properties
index 7c6c976..dee7e2c 100644
--- a/java/org/apache/catalina/loader/LocalStrings.properties
+++ b/java/org/apache/catalina/loader/LocalStrings.properties
@@ -59,6 +59,7 @@ webappClassLoader.wrongVersion=(unable to load class [{0}])
 webappClassLoaderParallel.registrationFailed=Registration of org.apache.catalina.loader.ParallelWebappClassLoader as capable of loading classes in parallel failed
 
 webappLoader.deploy=Deploying class repositories to work directory [{0}]
+webappLoader.noJakartaConverter=The Jakarta converter provided by the Tomcat migration tool could not be loaded
 webappLoader.noResources=No resources found for context [{0}]
 webappLoader.reloadable=Cannot set reloadable property to [{0}]
 webappLoader.setContext.ise=Setting the Context is not permitted while the loader is started.
diff --git a/java/org/apache/catalina/loader/WebappLoader.java b/java/org/apache/catalina/loader/WebappLoader.java
index a9d5ccc..33aad92 100644
--- a/java/org/apache/catalina/loader/WebappLoader.java
+++ b/java/org/apache/catalina/loader/WebappLoader.java
@@ -24,6 +24,7 @@ import java.io.IOException;
 import java.lang.instrument.ClassFileTransformer;
 import java.lang.reflect.Constructor;
 import java.lang.reflect.InvocationTargetException;
+import java.lang.reflect.Method;
 import java.net.URL;
 import java.net.URLClassLoader;
 import java.nio.charset.StandardCharsets;
@@ -41,8 +42,6 @@ import org.apache.catalina.util.LifecycleMBeanBase;
 import org.apache.catalina.util.ToStringUtil;
 import org.apache.juli.logging.Log;
 import org.apache.juli.logging.LogFactory;
-import org.apache.tomcat.jakartaee.ClassConverter;
-import org.apache.tomcat.jakartaee.EESpecProfile;
 import org.apache.tomcat.util.ExceptionUtils;
 import org.apache.tomcat.util.buf.UDecoder;
 import org.apache.tomcat.util.compat.JreCompat;
@@ -367,17 +366,24 @@ public class WebappLoader extends LifecycleMBeanBase implements Loader{
 
             // Set Jakarta class converter
             if (getJakartaConverter() != null) {
-                ClassFileTransformer transformer = null;
                 try {
-                    EESpecProfile profile = EESpecProfile.valueOf(getJakartaConverter());
-                    transformer = ClassConverter.class.getConstructor(EESpecProfile.class).newInstance(profile);
-                    // FIXME: after Migration 0.3
-                    //transformer = new ClassConverter(EESpecProfile.valueOf(getJakartaConverter()));
-                } catch (InvocationTargetException | NoSuchMethodException | IllegalArgumentException ignored) {
-                    // Use default value with no argument constructor
-                    transformer = new ClassConverter();
+                    ClassFileTransformer transformer = null;
+                    try {
+                        Class<?> jakartaEnumClass = Class.forName("org.apache.tomcat.jakartaee.EESpecProfile");
+                        Method valueOf = jakartaEnumClass.getMethod("valueOf", String.class);
+                        Object profile = valueOf.invoke(null, getJakartaConverter());
+                        transformer =
+                                (ClassFileTransformer) Class.forName("org.apache.tomcat.jakartaee.ClassConverter")
+                                .getConstructor(jakartaEnumClass).newInstance(profile);
+                    } catch (InvocationTargetException | NoSuchMethodException ignored) {
+                        // Use default value with no argument constructor
+                        transformer =
+                                (ClassFileTransformer) Class.forName("org.apache.tomcat.jakartaee.ClassConverter").newInstance();
+                    }
+                    classLoader.addTransformer(transformer);
+                } catch (InstantiationException | IllegalAccessException | ClassNotFoundException e) {
+                    log.warn(sm.getString("webappLoader.noJakartaConverter"), e);
                 }
-                classLoader.addTransformer(transformer);
             }
 
             // Configure our repositories
diff --git a/java/org/apache/catalina/startup/HostConfig.java b/java/org/apache/catalina/startup/HostConfig.java
index 9cd23e7..15b0182 100644
--- a/java/org/apache/catalina/startup/HostConfig.java
+++ b/java/org/apache/catalina/startup/HostConfig.java
@@ -68,7 +68,6 @@ import org.apache.catalina.util.ContextName;
 import org.apache.catalina.util.IOTools;
 import org.apache.juli.logging.Log;
 import org.apache.juli.logging.LogFactory;
-import org.apache.tomcat.jakartaee.Migration;
 import org.apache.tomcat.util.ExceptionUtils;
 import org.apache.tomcat.util.buf.UriUtil;
 import org.apache.tomcat.util.digester.Digester;
@@ -466,8 +465,6 @@ public class HostConfig implements LifecycleListener {
      * in our "application root" directory.
      */
     protected void deployApps() {
-        // Migrate legacy Java EE apps from legacyAppBase
-        migrateLegacyApps();
         File appBase = host.getAppBaseFile();
         File configBase = host.getConfigBaseFile();
         String[] filteredAppPaths = filterAppPaths(appBase.list());
@@ -1227,93 +1224,6 @@ public class HostConfig implements LifecycleListener {
     }
 
 
-    protected void migrateLegacyApps() {
-        File appBase = host.getAppBaseFile();
-        File legacyAppBase = host.getLegacyAppBaseFile();
-        if (!legacyAppBase.isDirectory()) {
-            return;
-        }
-
-        ExecutorService es = host.getStartStopExecutor();
-        List<Future<?>> results = new ArrayList<>();
-
-        // Should not be null as we test above if this is a directory
-        String[] migrationCandidates = legacyAppBase.list();
-        for (String migrationCandidate : migrationCandidates) {
-            File source = new File(legacyAppBase, migrationCandidate);
-            File destination = new File(appBase, migrationCandidate);
-
-            ContextName cn;
-            if (source.lastModified() > destination.lastModified()) {
-                if (source.isFile() && source.getName().toLowerCase(Locale.ENGLISH).endsWith(".war")) {
-                    cn = new ContextName(migrationCandidate, true);
-                } else if (source.isDirectory()) {
-                    cn = new ContextName(migrationCandidate, false);
-                } else {
-                    continue;
-                }
-
-                if (tryAddServiced(cn.getBaseName())) {
-                    try {
-                        // MigrateApp will call removeServiced
-                        results.add(es.submit(new MigrateApp(this, cn, source, destination)));
-                    } catch (Throwable t) {
-                        ExceptionUtils.handleThrowable(t);
-                        removeServiced(cn.getName());
-                        throw t;
-                    }
-                }
-            }
-        }
-
-        for (Future<?> result : results) {
-            try {
-                result.get();
-            } catch (Exception e) {
-                log.error(sm.getString("hostConfig.migrateApp.threaded.error"), e);
-            }
-        }
-    }
-
-
-    protected void migrateLegacyApp(File source, File destination) {
-        File tempNew = null;
-        File tempOld = null;
-        try {
-            tempNew = File.createTempFile("new", null, host.getLegacyAppBaseFile());
-            tempOld = File.createTempFile("old", null, host.getLegacyAppBaseFile());
-            // createTempFile is not directly compatible with directories, so cleanup
-            Files.delete(tempNew.toPath());
-            Files.delete(tempOld.toPath());
-
-            // The use of defaults is deliberate here to avoid having to
-            // recreate every configuration option on the host. Better to change
-            // the defaults if necessary than to start adding configuration
-            // options. Users that need non-default options can convert manually
-            // via migration.[sh|bat]
-            Migration migration = new Migration();
-            migration.setSource(source);
-            migration.setDestination(tempNew);
-            migration.execute();
-
-            // Use rename
-            if (destination.exists()) {
-                Files.move(destination.toPath(), tempOld.toPath());
-            }
-            Files.move(tempNew.toPath(), destination.toPath());
-            ExpandWar.delete(tempOld);
-
-        } catch (Throwable t) {
-            ExceptionUtils.handleThrowable(t);
-            log.warn(sm.getString("hostConfig.migrateError"), t);
-        } finally {
-            if (tempNew != null && tempNew.exists()) {
-                ExpandWar.delete(tempNew);
-            }
-        }
-    }
-
-
     /**
      * Check if a webapp is already deployed in this host.
      *
@@ -2020,30 +1930,6 @@ public class HostConfig implements LifecycleListener {
     }
 
 
-    private static class MigrateApp implements Runnable {
-
-        private HostConfig config;
-        private ContextName cn;
-        private File source;
-        private File destination;
-
-        public MigrateApp(HostConfig config, ContextName cn, File source, File destination) {
-            this.config = config;
-            this.cn = cn;
-            this.source = source;
-            this.destination = destination;
-        }
-
-        @Override
-        public void run() {
-            try {
-                config.migrateLegacyApp(source, destination);
-            } finally {
-                config.removeServiced(cn.getName());
-            }
-        }
-    }
-
 
     /*
      * The purpose of this class is to provide a way for HostConfig to get
diff --git a/java/org/apache/catalina/startup/LocalStrings.properties b/java/org/apache/catalina/startup/LocalStrings.properties
index b8d0aff..ba54588 100644
--- a/java/org/apache/catalina/startup/LocalStrings.properties
+++ b/java/org/apache/catalina/startup/LocalStrings.properties
@@ -136,7 +136,6 @@ hostConfig.ignorePath=Ignoring path [{0}] in appBase for automatic deployment
 hostConfig.illegalWarName=The war name [{0}] is invalid. The archive will be ignored.
 hostConfig.jmx.register=Register context [{0}] failed
 hostConfig.jmx.unregister=Unregister context [{0}] failed
-hostConfig.migrateApp.threaded.error=Error waiting for multi-thread migration of legacy applications to complete
 hostConfig.migrateError=Migration failure
 hostConfig.reload=Reloading context [{0}]
 hostConfig.resourceNotAbsolute=Unable to remove resource from context [{0}] since [{1}] is not an absolute path
